(define (sqrt x)
  (define (average a b) (/ (+ a b) 2))
  (define (good-enough? guess prev-guess)
    (< (abs (- guess prev-guess)) (/ guess 100000))
  )
  (define (improve guess)
    (average guess (/ x guess))
  )
  (define (sqrt-iter guess prev-guess)
    (if (good-enough? guess prev-guess)
      guess
      (sqrt-iter (improve guess) guess)
    )
  )
  (sqrt-iter 1.0 0.0)
)

(sqrt 0.01)
(sqrt 100000000000000)
